Index: anches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim2.card
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim2.card	(revision 4525)
+++ 	(revision )
@@ -1,28 +1,0 @@
-[Compatibility]
-libIGCM=1.0
-
-[UserChoices]
-
-[InitialStateFiles]
-List=	()
-
-[BoundaryFiles]
-List=	()
-ListNonDel= ()
-
-[ParametersFiles]
-List=	(${SUBMIT_DIR}/PARAM/namelist_ice_lim2, namelist_ice)
-
-[RestartFiles]
-List=	(${config_UserChoices_JobName}_${NEMO_END}_restart_ice.nc, restart_icemod.nc, restart_ice_in.nc)
-
-[OutputText]
-List=   (ice_evolu)
-
-[OutputFiles]
-List=   (${PREFIX_WFI1}_icemod.nc, ${R_OUT_ICE_WFI1}/${PREFIX}_${WFI1}_icemod.nc, Post_1M_icemod)
-
-[Post_1M_icemod]
-Patches = ()
-GatherWithInternal = (nav_lon, nav_lat, time_counter)
-TimeSeriesVars = (iicethic, ileadfra, isnowthi, iicevelu, iicevelv)
Index: anches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim2.driver
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim2.driver	(revision 4525)
+++ 	(revision )
@@ -1,56 +1,0 @@
-#!/bin/ksh
-
-#-----------------------------------
-function ICE_Initialize
-{ 
-    IGCM_debug_PushStack "ICE_Initialize"
-
-    echo INITIALIZE ICE !!!
-
-    IGCM_debug_PopStack "ICE_Initialize"
-}
-
-#-----------------------------------
-function ICE_Update
-{
-    IGCM_debug_PushStack "ICE_Update"
-
-    NbFreq=$( echo ${config_ICE_WriteFrequency} | wc -w )
-
-    ##--Write Frequency Purpose ....
-    typeset -Z1 i=1
-    while [ $i -le ${NbFreq} ]; do
-        frequency=$( echo ${config_ICE_WriteFrequency} | awk -v var="$i" "-F " '{print $var}' )
-        factor=$( echo ${frequency} | sed -e "s/[yYmMdD]//" )
-        case ${frequency} in
-            *Y|*y)
-                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}y_${DatesPeriod} ;
-                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_Y} ;
-                eval WFI${i}=${factor}Y ;;
-            *M|*m)
-                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}m_${DatesPeriod} ;
-                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_M} ;
-                eval WFI${i}=${factor}M ;;
-            *D|*d)
-                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}d_${DatesPeriod} ;
-                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_D} ;
-                eval WFI${i}=${factor}D ;;
-            *)
-        esac
-        let i=$i+1
-
-    done
-    echo UPDATE ICE !!!
-
-    IGCM_debug_PopStack "ICE_Update"
-}
-
-#-----------------------------------
-function ICE_Finalize
-{
-    IGCM_debug_PushStack "ICE_Finalize"
-
-    echo FINALIZE ICE !!!
-
-    IGCM_debug_PopStack "ICE_Finalize"
-}
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.card
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.card	(revision 4526)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.card	(revision 4526)
@@ -0,0 +1,33 @@
+[Compatibility]
+libIGCM=1.0
+
+[UserChoices]
+
+[InitialStateFiles]
+List=	()
+
+[BoundaryFiles]
+List=	()
+ListNonDel= ()
+
+[ParametersFiles]
+List=	(${SUBMIT_DIR}/PARAM/namelist_ice_lim3, namelist_ice)
+
+[RestartFiles]
+List=	(${config_UserChoices_JobName}_${NEMO_END}_restart_ice.nc, restart_icemod.nc, restart_ice.nc)
+
+[OutputText]
+List=   (ice_evolu)
+
+[OutputFiles]
+List=   (${PREFIX_WFI1}_icemod.nc, ${R_OUT_ICE_WFI1}/${PREFIX}_${WFI1}_icemod.nc,   NONE)
+
+[Post_1M_icemod]
+Patches = ()
+GatherWithInternal = (nav_lon, nav_lat, time_counter)
+TimeSeriesVars = (iicethic, ileadfra, isnowthi, iicevelu, iicevelv)
+
+[Post_1D_icemod]
+Patches = ()
+GatherWithInternal = (nav_lon, nav_lat, time_counter)
+TimeSeriesVars = (iicethic, ileadfra, isnowthi, iicevelu, iicevelv)
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.driver
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.driver	(revision 4526)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/COMP/lim3.driver	(revision 4526)
@@ -0,0 +1,56 @@
+#!/bin/ksh
+
+#-----------------------------------
+function ICE_Initialize
+{ 
+    IGCM_debug_PushStack "ICE_Initialize"
+
+    echo INITIALIZE ICE !!!
+
+    IGCM_debug_PopStack "ICE_Initialize"
+}
+
+#-----------------------------------
+function ICE_Update
+{
+    IGCM_debug_PushStack "ICE_Update"
+
+    NbFreq=$( echo ${config_ICE_WriteFrequency} | wc -w )
+
+    ##--Write Frequency Purpose ....
+    typeset -Z1 i=1
+    while [ $i -le ${NbFreq} ]; do
+        frequency=$( echo ${config_ICE_WriteFrequency} | awk -v var="$i" "-F " '{print $var}' )
+        factor=$( echo ${frequency} | sed -e "s/[yYmMdD]//" )
+        case ${frequency} in
+            *Y|*y)
+                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}y_${DatesPeriod} ;
+                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_Y} ;
+                eval WFI${i}=${factor}Y ;;
+            *M|*m)
+                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}m_${DatesPeriod} ;
+                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_M} ;
+                eval WFI${i}=${factor}M ;;
+            *D|*d)
+                eval PREFIX_WFI${i}=${config_UserChoices_JobName}_${factor}d_${DatesPeriod} ;
+                eval R_OUT_ICE_WFI${i}=${R_OUT_ICE_O_D} ;
+                eval WFI${i}=${factor}D ;;
+            *)
+        esac
+        let i=$i+1
+
+    done
+    echo UPDATE ICE !!!
+
+    IGCM_debug_PopStack "ICE_Update"
+}
+
+#-----------------------------------
+function ICE_Finalize
+{
+    IGCM_debug_PushStack "ICE_Finalize"
+
+    echo FINALIZE ICE !!!
+
+    IGCM_debug_PopStack "ICE_Finalize"
+}
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/config.card
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/config.card	(revision 4525)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/ORCA2_LIM3/IGCM00/config.card	(revision 4526)
@@ -1,4 +1,4 @@
 #
-# This is config.card file for NEMO ORCA2_LIM2 configuration
+# This is config.card file for NEMO ORCA2_LIM3 configuration
 #
 #========================================================================
@@ -47,5 +47,5 @@
 #D- For each component, Name of component, Tag of component
 OCE= (opa9, NEMO_v3)
-ICE= (lim2, LIM_2)
+ICE= (lim3, LIM_3)
 
 #========================================================================